<template>
  <form v-on:submit.prevent="uploadFile" accept-charset="UTF-8" enctype="multipart/form-data">
    <p class="alert alert-info info-alert" role="alert" v-if="display">{{message}}</p>
    <div class="form-group down-prompt">
      <img src="images/icons/cloud-upload.svg" alt="Download icon" class=""/>
      <p class="" @click="downloadSample">Download sample file</p>
    </div>
    <div class="form-group" v-bind:class="{'has-error': hasError}">
      <input accept=".csv" class="form-input custom-input" id="employees" name="employees" type="file" ref="file" v-on:change="handleFileUpload()">    
      <p class="form-input-hint" v-if="hasError">Error uploading file</p>
    </div>
    <div>
      <button class="float-right btn btn-custom" v-bind:class="{'disabled': isDisabled}">Upload File</button>
    </div>
  </form>
</template>
<script>
export default {
  data() {
    return{
      file: '',
      hasError: false,
      isDisabled: true,
      display: false,
      message: ""
    }
  },
  methods: {
    uploadFile(event) {
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      let formData = new FormData();
      const axios = require('axios');
      formData.append('employees', this.file);
      
      axios.post('/employees/upload',formData, { 
        headers: {'Content-Type': 'text/csv', 'x-csrf-token': csrf}
      }).then(response => {
        this.notify()
      }).catch(error => {
        this.hasError = true
      });

      event.target.reset();
      this.isDisabled = true
    },
    handleFileUpload(){
      this.file = this.$refs.file.files[0];
      this.isDisabled = false
      hasError: false
    },
    notify() {
      this.display = true
      this.message = "File successfully uploaded"  
      setTimeout(function () {
        window.location.reload();
      }, 2000);  
    },
    downloadSample(){
      const axios = require('axios');
      axios.get('/employees/sample/download', {
        responseType: 'blob'
      }).then((response) => {
        const url = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', 'sample.csv');
        document.body.appendChild(link);
        link.click();
      });
    }
  }
}
</script>
<style scoped>

</style>
